# 2dxAutoClip

Piccola applicazione portatile in C# (<1mb senza il binario di FFmpeg) creata per registrare e salvare clip delle tue sessioni di Beatmania IIDX. Scarica automaticamente FFMPEG al primo avvio. Sono disponibili dei binari precompilati aggiornati ogni 4-5 commit.

## Impostazioni Personalizzate:
Dalla versione 0.0.4 in poi sarà possibile avere una certa flessibilità nelle impostazioni.
Il nuovo file [prop](https://git.mercurio.moe/Mercury/2dxAutoClip/src/branch/main/2dxAutoClip/artifacts/prop.txt) consentirà all'utente di regolare finemente alcune impostazioni come la risoluzione di registrazione (Consigliamo registrare a 720p tutti le versioni precedenti a Resident), il Constant Rate Factor (CRF) che determina la qualità e la velocità della registrazione, anche se suggeriamo di mantenerlo al valore predefinito, e il framerate del video sorgente; anche in questo caso, suggeriamo di mantenerlo a 60 o 120, poiché l'output finale forzerà il framerate a 60. Questa versione consente anche all'utente di passare alla registrazione con `spice`, `inject` e `launcher` invece di `spice64` per registrare versioni più vecchie o giochi avviati da BemaniTools.

## Requisiti:
- **ALMENO Windows 10 build 20348**
- Un'installazione abbastanza recente di beatmania iidx con [TickerHook](https://github.com/Radioo/TickerHook) in esecuzione. Tutti i crediti vanno all'autore originale
- Circa 2MB per estrarre la versione precompilata dell'applicazione e 100MB una volta completato il download dei file di supporto come FFMPEG e AppLbCap
- Runtime [.net 8 (64 bit)](https://dotnet.microsoft.com/it-it/download/dotnet/thank-you/runtime-8.0.8-windows-x64-installer) per l'esecuzione, SDK [.net 8 (64 bit)](https://dotnet.microsoft.com/it-it/download/dotnet/thank-you/sdk-8.0.401-windows-x64-installer) se si desidera compilarlo autonomamente
- FFMPEG aggiunto al PATH di sistema (opzionale. Il programma scaricherà una versione precompilata di FFMPEG se non ne trova una)
- ApplicationLoopbackCapture verrà scaricato a runtime. In alternativa, puoi scaricarlo da [qui](https://git.mercurio.moe/Mercury/2dxAutoClip-AppLbHelper) e compilarlo autonomamente (richiede VS 2019+)


## Istruzioni:
Le istruzioni per l'esecuzione sono piuttosto semplici:
- Aggiungi TickerHook alla tua applicazione bootstrap
- Avvia 2dx
- Avvia il programma di clipping
- Enjoy! :D

Ecco come puoi aggiungere TickerHook al tuo bootstrap preferito:
- **Bemanitools (IIDX9-17)**

Modifica il tuo gamestart per aggiungere tickerhook.dll subito dopo iidxhook*.dll:

`inject iidxhook1.dll TickerHook.dll bm2dx.exe --config iidxhook-09.conf %*`

- **Bemanitools (IIDX18-30)**

Modifica il tuo gamestart.bat per aggiungere tickerhook.dll dopo iidxhook*.dll:

`launcher -K iidxhook6.dll bm2dx.dll --config iidxhook-20.conf %*`

- **Spicetools**

Il metodo più semplice è aggiungere "tickerhook.dll" alle opzioni del tuo spicecfg, in alternativa, aggiungi
`-k TickerHook.dll` al tuo file start.bat, assicurandoti che la dll di Ticker sia nella cartella del gioco.

## Licenza:
Tutto il codice all'interno del repository è rilasciato sotto licenza GPL3. La (https://github.com/FFmpeg/FFmpeg/blob/master/LICENSE.md) di FFMPEG è disponibile qui.