# 2dxAutoClip
**Readme italiano disponibile** [qui](https://git.mercurio.moe/Mercury/2dxAutoClip/src/branch/main/readme-ita.md)

Tiny (<1mb without ffmpeg binary), portable c# application made to record and save clips of your beatmania IIDX sessions. Downloads FFMPEG on startup.
Prebuilt binaries are available as releases, and they get updated every few commits.

## Custom Settings:
Version 0.0.4 and onwards will allow for some flexibility in the settings.
the new [prop](https://git.mercurio.moe/Mercury/2dxAutoClip/src/branch/main/2dxAutoClip/artifacts/prop.txt) file will allwo the user to finely tune some settings such as recording resolution (older styles might be better off recorded at 720p or lower), the Constant Rate Factor (CRF) that dictates the quality and speed of the recording, although we suggest keeping it at default, and the framerate of the source video, again, we suggest keeping it at either 60 or 120 since the final export will force it back to 60.
This version also allows the user to switch to recording `spice` instead of `spice64` for the aforementioned older styles 

## Requirements:
- **AT LEAST Windows 10 build 20348**
- A fairly modern beatmania iidx install running [TickerHook](https://github.com/Radioo/TickerHook). All credit goes to original author
- About 2mb to extract the precompiled version of the application, and 100MB once it finishes downloading helper files such as FFMPEG and AppLbCap
- [.net 8 runtime(64 bit)](https://dotnet.microsoft.com/it-it/download/dotnet/thank-you/runtime-8.0.8-windows-x64-installer) for running, [.net8 SDK(64 bit)](https://dotnet.microsoft.com/it-it/download/dotnet/thank-you/sdk-8.0.401-windows-x64-installer) if you want to build it yourself 
- FFMPEG added to path (optional. the program will download a prebuilt version of ffmpeg if it can't find one)
- ApplicationLoopbackCapture will be downloaded at runtime. you can alternatively pull it from [here](https://git.mercurio.moe/Mercury/2dxAutoClip-AppLbHelper) and build it yourself (requires VS 2019+)

## Instructions:
Instructions for running boil down pretty much to:
- add tickerhook to your boostrap application
- launch 2dx
- launch clipping program
- profit :D

Here's how you can add your tickerhook to your bootstrap of choice:
- **Bemanitools (IIDX9-17)**

modify your gamestart to add tickerhook.dll right after iidxhook*.dll:

`inject iidxhook1.dll TickerHook.dll bm2dx.exe --config iidxhook-09.conf %*`

- **Bemanitools (IIDX18-30)**

Edit your gamestart to add tickerhook.dll after iidxhook*.dll

`launcher -K iidxhook6.dll bm2dx.dll --config iidxhook-20.conf %*`

- **Spicetools**

Easiest method is to add "tickerhook.dll" to your spicecfg options, alternatively, add
`-k TickerHook.dll` to your start.bat file, making sure the ticker dll is in the game folder

## Licensing:

All the code inside the repository is licensed under GPL3, FFMPEG follows this [licensing](https://github.com/FFmpeg/FFmpeg/blob/master/LICENSE.md). 